# -*- coding: utf-8 -*-
import sys, re, base64
from bs4 import BeautifulSoup
try:
    from urllib2 import urlopen, Request
except ImportError:
    from urllib.request import urlopen, Request
try:
    from urlparse import urlparse, urljoin
except ImportError:
    from urllib.parse import urlparse, urljoin
try:
    from urllib import urlencode, quote
except ImportError:
    from urllib.parse import urlencode, quote
ua = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/90.0.4430.85 Safari/537.36'


def gethttp(url):
    request = Request(url, headers={'User-Agent': ua})
    return urlopen(request).read().decode('utf-8')


def getsoup(url):
    request = Request(url, headers={'User-Agent': ua})
    if (2, 7, 3) <= sys.version_info < (3, 0) or (3, 2) <= sys.version_info < (4, 0):
        return BeautifulSoup(urlopen(request), 'html.parser')
    return BeautifulSoup(urlopen(request), 'html5lib')


def detail(url):
    def d(s):
        r = u''
        i = 0
        while i < len(s):
            if s[i:i+2] == '%u':
                try:
                    r += unichr(int(s[i+2:i+6], 16))
                except NameError:
                    r += chr(int(s[i + 2:i + 6], 16))
                i += 6
                continue
            if s[i:i+1] == '%':
                r += chr(int(s[i+1:i+3], 16))
                i += 3
                continue
            r += s[i]
            i += 1
        return r
    o = urlparse(url)
    p = o.path.split('/')
    id = re.search(r'vod-detail-id-(\d+).html', p[-1])
    if not id:
        return {'code': 'pangzitv 300'}
    id = id.group(1)
    url = 'https://www.pangzitv.com/vod-play-id-%s-src-1-num-1.html' % id
    try:
        content = gethttp(url)
    except Exception as e:
        return {'code': 'pangzitv 301', 'error': str(e)}
    ret = []
    content = re.search(r'base64decode\((.*?)\)', content)
    if not content:
        return {'code': 'pangzitv 302'}
    content = content.group(1)
    content = base64.decodestring(content.encode('utf-8')).decode('utf-8')
    content = d(content)
    for e in content.split('#'):
        a = e.split('$')
        ret.append({a[0]: a[1]})
    return ret


def category(cat, page=1):
    url = 'https://www.pangzitv.com/vod-type-id-%s-pg-%d.html' % (cat, page)
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'pangzitv 200', 'error': str(e)}
    ret = []
    for e in soup.select('div.imgItemWrp'):
        e1 = e.select('div.nameWrp a')[0]
        e2 = e.select('div.imgItem a img')[0]
        e3 = e.select('div.imgItem div.updateEpisode')[0]
        ret.append({'title': e1.text, 'url': urljoin(url, e1['href']), 'img': urljoin(url, e2['src']), 'plot': e3.text})
    total = soup.select('input.pagebtn')
    if total:
        total = total[0]['onclick']
        total = re.search(r'.*?\(.*?,(.*?)\)', total)
        if total:
            total = int(total.group(1))
            if page < total:
                ret.append({'title': 'Next Page(%d/%d)' % (page + 1, total), 'category': cat, 'page': page + 1})
    return ret


def search(s, page=1):
    if not s:
        return {'code': 'pangzitv 300'}
    url = 'https://www.pangzitv.com/vod-search-pg-%d-wd-%s.html' % (page, quote(s))
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'pangzitv 300', 'error': str(e)}
    ret = []
    for e in soup.select('div.imgItemWrp'):
        e1 = e.select('div.nameWrp a')[0]
        e2 = e.select('div.imgItem a img')[0]
        e3 = e.select('div.imgItem div.updateEpisode')[0]
        ret.append({'title': e1.text, 'url': urljoin(url, e1['href']), 'img': urljoin(url, e2['src']), 'plot': e3.text})
    total = soup.select('input.pagebtn')
    if total:
        total = total[0]['onclick']
        total = re.search(r'.*?\(.*?,(.*?)\)', total)
        if total:
            total = int(total.group(1))
            if page < total:
                ret.append({'title': 'Next Page(%d/%d)' % (page + 1, total), 'search': s, 'page': page + 1})
    return ret
